diff --git a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/dao/hibernate/statistics/StatisticsDaoHibernateImplTest.java b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/dao/hibernate/statistics/StatisticsDaoHibernateImplTest.java
new file mode 100644
index 0000000000..880dd49e7c
--- /dev/null
+++ b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/dao/hibernate/statistics/StatisticsDaoHibernateImplTest.java
@@ -0,0 +1,573 @@
+package eu.etaxonomy.cdm.persistence.dao.hibernate.statistics;
+
+import static org.junit.Assert.assertTrue;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Random;
+import java.util.Set;
+import java.util.UUID;
+
+import org.apache.commons.lang.RandomStringUtils;
+import org.apache.log4j.Logger;
+import org.junit.After;
+import org.junit.Before;
+import org.junit.Test;
+import org.unitils.spring.annotation.SpringBeanByType;
+
+import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
+import eu.etaxonomy.cdm.model.description.CommonTaxonName;
+import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
+import eu.etaxonomy.cdm.model.description.DescriptionElementSource;
+import eu.etaxonomy.cdm.model.description.TaxonDescription;
+import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
+import eu.etaxonomy.cdm.model.description.TextData;
+import eu.etaxonomy.cdm.model.name.BotanicalName;
+import eu.etaxonomy.cdm.model.name.Rank;
+import eu.etaxonomy.cdm.model.reference.Reference;
+import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
+import eu.etaxonomy.cdm.model.taxon.Classification;
+import eu.etaxonomy.cdm.model.taxon.Synonym;
+import eu.etaxonomy.cdm.model.taxon.SynonymRelationshipType;
+import eu.etaxonomy.cdm.model.taxon.Taxon;
+import eu.etaxonomy.cdm.model.taxon.TaxonNode;
+import eu.etaxonomy.cdm.model.view.context.AuditEventContextHolder;
+import eu.etaxonomy.cdm.persistence.dao.description.IDescriptionDao;
+import eu.etaxonomy.cdm.persistence.dao.description.IDescriptionElementDao;
+import eu.etaxonomy.cdm.persistence.dao.reference.IReferenceDao;
+import eu.etaxonomy.cdm.persistence.dao.statistics.IStatisticsDao;
+import eu.etaxonomy.cdm.persistence.dao.taxon.IClassificationDao;
+import eu.etaxonomy.cdm.persistence.dao.taxon.ITaxonDao;
+import eu.etaxonomy.cdm.persistence.dao.taxon.ITaxonNodeDao;
+import eu.etaxonomy.cdm.test.integration.CdmTransactionalIntegrationTest;
+
+public class StatisticsDaoHibernateImplTest extends
+		CdmTransactionalIntegrationTest {
+
+	private static final boolean PRINTOUT = true;
+
+	@SpringBeanByType
+	private IStatisticsDao statisticsDao;
+
+	private UUID nodeUuid;
+
+	private List<Classification> classifications;
+
+	private static final Logger logger = Logger
+			.getLogger(StatisticsDaoHibernateImplTest.class);
+
+	// choose a number
+	private static final int NO_OF_ACCEPTED_TAXA = 10;
+
+	// choose a number (less than NO_OF_ACCEPTED_TAXA)
+	private static final int NO_OF_CLASSIFICATIONS = 3;
+
+	// must be less or equal to NO_OF_ACCEPTED_TAXA
+	private static final int NO_OF_SYNONYMS = 7;
+
+	// taxa that occure in several classifications:
+	// must NOT be more than NO_OF_ACCEPTED_TAXA
+	private static final int NO_OF_SHARED_TAXA = 4;
+
+	// must be NO_OF_ACCEPTED_TAXA + NO_OF_SYNONYMS
+	private static final int NO_OF_ALLTAXA = NO_OF_ACCEPTED_TAXA
+			+ NO_OF_SYNONYMS;
+
+	// must be NO_OF_ACCEPTED_TAXA+NO_OF_SYNONYMS
+	private static final int NO_OF_TAXON_NAMES = NO_OF_ACCEPTED_TAXA
+			+ NO_OF_SYNONYMS;
+
+	// this represents an approx. no of the amount that will actually generated!
+	private static final int NO_OF_DESCRIPTIVE_SOURCE_REFERENCES = 16;
+
+	// private static final int NO_OF_ALL_REFERENCES = NO_OF_ACCEPTED_TAXA + 0;
+
+	// must not be more than NO_OF_ACCEPTED_TAXA+NO_OF_SYNONYMS
+	private static final int NO_OF_NOMECLATURAL_REFERENCES = NO_OF_ACCEPTED_TAXA
+			+ NO_OF_SYNONYMS - 4;
+
+	// --------------------variables for all ------------------
+
+	private Long no_of_all_references = new Long(0);
+	private Long no_of_descriptive_source_references = new Long(0);
+
+	// ............................................
+
+	// log the type enum to an int constant:
+	private Map<String, Long> typeMap_ALL;
+
+	// ------------------ variables for CLASSIFICATIONS -----------------------
+
+	// int[] anArray = new int[NO_OF_CLASSIFICATIONS];
+	private static List<Long> no_of_all_taxa_c = new ArrayList<Long>(
+			Collections.nCopies(NO_OF_CLASSIFICATIONS, new Long(0)));
+	private static List<Long> no_of_accepted_taxa_c = new ArrayList<Long>(
+			Collections.nCopies(NO_OF_CLASSIFICATIONS, new Long(0)));
+	private static List<Long> no_of_synonyms_c = new ArrayList<Long>(
+			Collections.nCopies(NO_OF_CLASSIFICATIONS, new Long(0)));
+	private static List<Long> no_of_taxon_names_c = new ArrayList<Long>(
+			Collections.nCopies(NO_OF_CLASSIFICATIONS, new Long(0)));
+	private static List<Long> no_of_descriptive_source_references_c = new ArrayList<Long>(
+			Collections.nCopies(NO_OF_CLASSIFICATIONS, new Long(0)));
+	private static List<Long> no_of_all_references_c = new ArrayList<Long>(
+			Collections.nCopies(NO_OF_CLASSIFICATIONS, new Long(0)));
+	private static List<Long> no_of_nomenclatural_references_c = new ArrayList<Long>(
+			Collections.nCopies(NO_OF_CLASSIFICATIONS, new Long(0)));
+	// we do not count classifications in classifications
+
+	// ........................... constant map ..........................
+
+	private static final Map<String, List<Long>> typeCountMap_CLASSIFICATION = new HashMap<String, List<Long>>() {
+		{
+			put("CLASSIFICATION",
+					new ArrayList<Long>(Arrays.asList((Long) null, null, null)));
+			put("ALL_TAXA", no_of_all_taxa_c);
+			put("ACCEPTED_TAXA", no_of_accepted_taxa_c);
+			put("SYNONYMS", no_of_synonyms_c);
+			put("TAXON_NAMES", no_of_taxon_names_c);
+			put("DESCRIPTIVE_SOURCE_REFERENCES",
+					no_of_descriptive_source_references_c);
+			put("ALL_REFERENCES", no_of_all_references_c);
+			put("NOMECLATURAL_REFERENCES", no_of_nomenclatural_references_c);
+		}
+	};
+
+	// ****************** services: ************************
+	@SpringBeanByType
+	private IStatisticsDao service;
+	@SpringBeanByType
+	private IClassificationDao classificationDao;
+	@SpringBeanByType
+	private ITaxonDao taxonDao;
+	@SpringBeanByType
+	private IReferenceDao referenceDao;
+	@SpringBeanByType
+	private IDescriptionDao descriptionDao;
+	@SpringBeanByType
+	private IDescriptionElementDao descriptionElementDao;
+	@SpringBeanByType
+	private ITaxonNodeDao taxonNodeDao;
+	
+	private UUID rootUuid;
+
+	@Before
+	public void setUp() {
+		// nodeUuid =UUID.fromString("46cd7e78-f7d5-4c31-937b-2bc5074618c4");
+		nodeUuid = UUID.fromString("0b5846e5-b8d2-4ca9-ac51-099286ea4adc");
+
+		AuditEventContextHolder.clearContext();
+
+	}
+
+	@After
+	public void tearDown() {
+		AuditEventContextHolder.clearContext();
+	}
+
+	@Test
+	// @DataSet
+	public void testGetAllChildNodes() {
+		List<UUID> result;
+		createDataSet();
+		for (Classification classification : classifications) {
+			TaxonNode root;
+			root= createTaxTree(classification);
+			result=statisticsDao.getAllChildNodeIds(root.getUuid());
+			System.out.println("classification "+ classification.getName()+": ");
+			System.out.println("result: "+result.toString());
+			System.out.println("");
+		}
+		if (PRINTOUT) {
+			print();
+		}
+		// result=statisticsDao.getAllTaxonIds(nodeUuid);
+		// statisticsDao.getAllTaxonIds();
+		assertTrue(true);
+		// fail("Not yet implemented");
+	}
+
+	private void createDataSet() {
+		// create NO_OF_CLASSIFICATIONS classifications
+		classifications = new ArrayList<Classification>();
+
+		for (int i = 1; i <= NO_OF_CLASSIFICATIONS; i++) {
+			Classification classification = Classification
+					.NewInstance("European Abies" + i);
+			classifications.add(classification);
+			classificationDao.save(classification);
+		}
+		// create all taxa, references and synonyms and attach them to one or
+		// more classifications
+
+		// variables: flags
+		int remainder = NO_OF_ACCEPTED_TAXA;
+		Reference sec = ReferenceFactory.newBook();
+		boolean secondClassificationForTaxonFlag = false;
+		boolean synonymFlag = false;
+		boolean tNomRefFlag = false;
+		boolean sNomRefFlag = false;
+		boolean tDescrSourceRefFlag = false;
+		boolean sDescrSourceRefFlag = false;
+
+		// variables: counter (pre-loop)
+		int descriptiveElementsPerTaxon = (NO_OF_DESCRIPTIVE_SOURCE_REFERENCES / NO_OF_ACCEPTED_TAXA) + 1;
+
+		int taxaInClass;
+		int classiCounter = 0, sharedClassification = 0, synonymCounter = 0, nomRefCounter = 0;
+
+		// iterate over classifications and add taxa
+		for (/* see above */; remainder > 0
+				&& classiCounter < NO_OF_CLASSIFICATIONS; /* see below */) {
+
+			// compute no of taxa to be created in this classification
+			if (classiCounter >= NO_OF_CLASSIFICATIONS - 1) { // last
+																// classification
+																// gets all left
+																// taxa
+				taxaInClass = remainder;
+			} else { // take half of left taxa for this class:
+				taxaInClass = remainder / 2;
+			}
+
+			// iterate over amount of taxa meant to be in this classification
+			for (int taxonCounter = 1; taxonCounter <= taxaInClass; taxonCounter++) {
+
+				// create a String for the Name
+				RandomStringUtils.randomAlphabetic(10);
+				String randomName = RandomStringUtils.randomAlphabetic(5) + " "
+						+ RandomStringUtils.randomAlphabetic(10);
+
+				// create a name for the taxon
+				BotanicalName name = BotanicalName.NewInstance(Rank.SPECIES());
+				name.setNameCache(randomName, true);
+
+				// create nomenclatural reference for taxon name (if left)
+				if (nomRefCounter < NO_OF_NOMECLATURAL_REFERENCES) {
+					// we remember this taxon has a nomenclatural reference:
+					tNomRefFlag = true;
+					Reference nomRef = ReferenceFactory.newBook();
+					name.setNomenclaturalReference(nomRef);
+					referenceDao.save(nomRef);
+					nomRefCounter++;
+				}
+
+				// create a new sec for every other taxon
+				if (taxonCounter % 2 != 0) {
+					sec = createSecReference(classiCounter, taxonCounter);
+				}
+
+				// create the taxon
+				Taxon taxon = Taxon.NewInstance(name, sec);
+
+				// create descriptions, description sources and their references
+
+				if (no_of_descriptive_source_references < NO_OF_DESCRIPTIVE_SOURCE_REFERENCES) {
+
+					tDescrSourceRefFlag = true;
+
+					// create a description and 2 description elements with
+					// references for taxon name
+					TaxonNameDescription nameDescr = TaxonNameDescription.NewInstance();
+					CommonTaxonName nameElement = CommonTaxonName.NewInstance(
+							"Veilchen" + taxonCounter, Language.GERMAN());
+					TextData textElement = new TextData();
+					Reference nameElementRef = ReferenceFactory.newArticle();
+					Reference textElementRef = ReferenceFactory
+							.newBookSection();
+					nameElement.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, nameElementRef, "name: ");
+					textElement.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, textElementRef, "text: ");
+					nameDescr.addElement(nameElement);
+					nameDescr.addElement(textElement);
+					name.addDescription(nameDescr);
+					// taxon.getName().addDescription(nameDescr);
+					referenceDao.save(nameElementRef);
+					referenceDao.save(textElementRef);
+					descriptionDao.save(nameDescr);
+
+					// create descriptions, description sources and their
+					// references
+					// for taxon
+					TaxonDescription taxonDescription = new TaxonDescription();
+					for (int i = 0; i < descriptiveElementsPerTaxon; i++) {
+						DescriptionElementBase descriptionElement = new TextData();
+						DescriptionElementSource descriptionElementSource = DescriptionElementSource
+								.NewInstance(OriginalSourceType.PrimaryTaxonomicSource);
+						Reference article = ReferenceFactory.newArticle();
+
+						descriptionElementSource.setCitation(article);
+						descriptionElement.addSource(descriptionElementSource);
+						taxonDescription.addElement(descriptionElement);
+						referenceDao.save(article);
+						descriptionElementDao.save(descriptionElement);
+
+					}
+					descriptionDao.save(taxonDescription);
+					taxon.addDescription(taxonDescription);
+
+					// create a Specimen for taxon with description, descr.
+					// element and referece
+					//
+					// Specimen specimen = Specimen.NewInstance();
+					// SpecimenDescription specimenDescription =
+					// SpecimenDescription.NewInstance(specimen);
+					// DescriptionElementBase descrElement = new TextData();
+					// Reference specimenRef = ReferenceFactory.newArticle();
+					// descrElement.addSource(null, null, specimenRef, null);
+					//
+					//
+					// descriptionService.save(specimenDescription);
+					// taxon.add(specimen);
+
+					no_of_descriptive_source_references += descriptiveElementsPerTaxon + 2 + 1;
+
+				}
+
+				// add taxon to classification
+				classifications.get(classiCounter).addChildTaxon(taxon, null, null);
+
+				// now if there are any left, we create a synonym for the taxon
+				if (synonymCounter < NO_OF_SYNONYMS) {
+					synonymFlag = true;
+					randomName = RandomStringUtils.randomAlphabetic(5) + " "
+							+ RandomStringUtils.randomAlphabetic(10);
+					// name for synonym
+					name = BotanicalName.NewInstance(Rank.SPECIES());
+					name.setNameCache(randomName, true);
+
+					// create nomenclatural reference for synonym name (if left)
+					if (nomRefCounter < NO_OF_NOMECLATURAL_REFERENCES) {
+						sNomRefFlag = true;
+						Reference nomRef = ReferenceFactory.newBook();
+						name.setNomenclaturalReference(nomRef);
+						referenceDao.save(nomRef);
+						nomRefCounter++;
+					}
+
+					if (no_of_descriptive_source_references < NO_OF_DESCRIPTIVE_SOURCE_REFERENCES) {
+						sDescrSourceRefFlag = true;
+
+						// create a description and 2 description elements with
+						// references for synonym name
+						TaxonNameDescription nameDescr = TaxonNameDescription.NewInstance();
+						CommonTaxonName nameElement = CommonTaxonName
+								.NewInstance("anderes Veilchen" + taxonCounter,
+										Language.GERMAN());
+						TextData textElement = new TextData();
+						Reference nameElementRef = ReferenceFactory.newArticle();
+						Reference textElementRef = ReferenceFactory.newBookSection();
+						nameElement.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, nameElementRef,"name: ");
+						textElement.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, textElementRef,"text: ");
+						nameDescr.addElement(nameElement);
+						nameDescr.addElement(textElement);
+						name.addDescription(nameDescr);
+						// taxon.getName().addDescription(nameDescr);
+						referenceDao.save(nameElementRef);
+						referenceDao.save(textElementRef);
+						descriptionDao.save(nameDescr);
+						no_of_descriptive_source_references += 2;
+					}
+
+					// create a new reference for every other synonym:
+					if (taxonCounter % 2 != 0) {
+						sec = createSecReference(classiCounter, taxonCounter);
+					}
+					Synonym synonym = Synonym.NewInstance(name, sec);
+					taxonDao.save(synonym);
+					taxon.addSynonym(synonym,
+							SynonymRelationshipType.SYNONYM_OF());
+
+					synonymCounter++;
+				}
+
+				// if this is not the last classification and there are
+				// taxa left that should be in more than one classification
+				// we add the taxon to the next class in the list too.
+				if (classiCounter < NO_OF_CLASSIFICATIONS
+						&& sharedClassification < NO_OF_SHARED_TAXA) {
+					classifications.get(classiCounter + 1).addChildTaxon(taxon, null, null);
+
+					// we remember that this taxon is attached to 2
+					// classifications:
+					secondClassificationForTaxonFlag = true;
+					sharedClassification++;
+					classificationDao.saveOrUpdate(classifications
+							.get(classiCounter + 1));
+				}
+
+				taxonDao.save(taxon);
+				classificationDao.saveOrUpdate(classifications
+						.get(classiCounter));
+
+				// count the data created with this taxon:
+				int c = classiCounter;
+
+				if (secondClassificationForTaxonFlag) {
+					c++;
+				}
+
+				// run the following loop once, if this taxon only belongs to
+				// one
+				// classification.
+				// twice, if it is attached to 2 classifications
+				for (int i = classiCounter; i <= c; i++) {
+
+					// count everything just created for this taxon:
+					increment(no_of_accepted_taxa_c, i);
+					increment(no_of_taxon_names_c, i);
+					if (tNomRefFlag) {
+						increment(no_of_nomenclatural_references_c, i);
+					}
+					if (sNomRefFlag) {
+						increment(no_of_nomenclatural_references_c, i);
+					}
+					if (synonymFlag) {
+						increment(no_of_synonyms_c, i);
+						increment(no_of_taxon_names_c, i);
+					}
+					if (taxonCounter % 2 != 0) {
+						increment(no_of_all_references_c, i);
+						if (synonymFlag) {
+							increment(no_of_all_references_c, i);
+						}
+					}
+					if (tDescrSourceRefFlag) {
+						increment(no_of_descriptive_source_references_c, i,
+								descriptiveElementsPerTaxon + 2);
+					}
+
+					if (sDescrSourceRefFlag) {
+						increment(no_of_descriptive_source_references_c, i, 2);
+					}
+				}
+				// put flags back:
+				secondClassificationForTaxonFlag = false;
+				tNomRefFlag = false;
+				sNomRefFlag = false;
+				synonymFlag = false;
+				tDescrSourceRefFlag = false;
+				sDescrSourceRefFlag = false;
+			}
+
+			// modify variables (post-loop)
+			classiCounter++;
+			remainder -= taxaInClass;
+
+		}
+		merge(no_of_accepted_taxa_c, no_of_synonyms_c, no_of_all_taxa_c);
+		merge(no_of_all_references_c, no_of_nomenclatural_references_c,
+				no_of_all_references_c);
+
+		// TODO Auto-generated method stub
+
+	}
+
+	/**
+	 * create and count a new sec Reference
+	 * 
+	 * @param classiCounter
+	 * @param taxonCounter
+	 * @return
+	 */
+	private Reference createSecReference(int classiCounter, int taxonCounter) {
+		Reference sec;
+		sec = ReferenceFactory.newBook();
+		sec.setTitle("book " + classiCounter + "." + taxonCounter);
+		referenceDao.save(sec);
+		no_of_all_references++;
+		return sec;
+	}
+
+	/**
+	 * @param no_of_sth
+	 * @param inClassification
+	 * @param increase
+	 */
+	private void increment(List<Long> no_of_sth, int inClassification,
+			int increase) {
+		no_of_sth.set(inClassification, (no_of_sth.get(inClassification))
+				+ increase);
+	}
+
+	private void increment(List<Long> no_of_sth, int inClassification) {
+		increment(no_of_sth, inClassification, 1);
+	}
+
+	private void merge(List<Long> no_of_sth1, List<Long> no_of_sth2,
+			List<Long> no_of_sum) {
+
+		for (int i = 0; i < NO_OF_CLASSIFICATIONS; i++) {
+			Long sum = no_of_sth1.get(i) + no_of_sth2.get(i);
+			no_of_sum.set(i, sum);
+
+		}
+	}
+
+	private TaxonNode createTaxTree(Classification classification) {
+		Random rand = new Random();
+		
+			Set<TaxonNode> nodes = classification.getAllNodes();
+			ArrayList<TaxonNode> children = new ArrayList<TaxonNode>();
+			TaxonNode parent = nodes.iterator().next();
+			
+			TaxonNode root = parent;
+			nodes.remove(parent);
+			while (!nodes.isEmpty()) {
+				int n = rand.nextInt(2) + 1;
+				for (int i = 1; i <= n && !(nodes.isEmpty()); i++) {
+					TaxonNode nextNode = nodes.iterator().next();
+					parent.getChildNodes().add(nextNode);
+					children.add(nextNode);
+					nodes.remove(nextNode);
+				}
+				taxonNodeDao.save(parent);
+				parent = children.get(0);
+				children.remove(0);
+			}
+		return root;
+	}
+
+	/**
+	 * 
+	 */
+	private void print() {
+		for (Classification classification : classifications) {
+			System.out.println("Classification:" + classification.toString());
+			for (TaxonNode node : classification.getAllNodes()) {
+				System.out.println("\tTaxon: " + node.getTaxon().toString()+" node UUID: "+ node.getUuid());
+				System.out.println(" \t(Name: "
+						+ node.getTaxon().getName().toString() + ")");
+				System.out.print("\tChildren: ");
+				for (TaxonNode childNode : node.getChildNodes()) {
+					System.out.print(/*childNode.getTaxon().getName() + */" node UUID: "+ node.getUuid()+"   ");
+				}
+				System.out.println();
+
+				if (node.getTaxon().getName().getNomenclaturalReference() != null) {
+					System.out.println(" \t(Nomencl. Ref.: "
+							+ node.getTaxon().getName()
+									.getNomenclaturalReference().getId() + ")");
+				}
+				for (Synonym synonym : node.getTaxon().getSynonyms()) {
+					System.out.println("\t\tSynonym: " + synonym.toString());
+					System.out.println(" \t\t(Name: "
+							+ synonym.getName().toString() + ")");
+					if (synonym.getName().getNomenclaturalReference() != null) {
+						System.out.println(" \t\t(Nomencl. Ref.: "
+								+ synonym.getName().getNomenclaturalReference()
+										.getId() + ")");
+					}
+					System.out.println();
+				}
+			}
+
+		}
+		System.out.println();
+		System.out.println("end!");
+
+	}
+}
diff --git a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/TaxonNodeDaoHibernateImplTest.java b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/TaxonNodeDaoHibernateImplTest.java
index 84a18b3b9c..aa1bc14925 100644
--- a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/TaxonNodeDaoHibernateImplTest.java
+++ b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/dao/hibernate/taxon/TaxonNodeDaoHibernateImplTest.java
@@ -18,6 +18,7 @@ import java.util.Set;
 import java.util.UUID;
 
 import org.junit.After;
+import org.junit.Assert;
 import org.junit.Before;
 import org.junit.Test;
 import org.unitils.dbunit.annotation.DataSet;
@@ -45,12 +46,13 @@ public class TaxonNodeDaoHibernateImplTest extends CdmTransactionalIntegrationTe
     private ITaxonDao taxonDao;
 
     private UUID uuid1;
-    private UUID uuid2;
     private UUID uuid3;
+    private UUID uuid2;
 
     @Before
     public void setUp(){
-        uuid1 = UUID.fromString("20c8f083-5870-4cbd-bf56-c5b2b98ab6a7");
+    	uuid1 = UUID.fromString("0b5846e5-b8d2-4ca9-ac51-099286ea4adc");
+        uuid3 = UUID.fromString("20c8f083-5870-4cbd-bf56-c5b2b98ab6a7");
         uuid2 = UUID.fromString("770239f6-4fa8-496b-8738-fe8f7b2ad519");
         AuditEventContextHolder.clearContext();
     }
@@ -71,8 +73,7 @@ public class TaxonNodeDaoHibernateImplTest extends CdmTransactionalIntegrationTe
     @Test
     @DataSet
     public void testFindByUuid() {
-        TaxonNode taxonNode = (TaxonNode) taxonNodeDao.findByUuid(uuid1);
-        Classification.class.getDeclaredConstructors();
+        TaxonNode taxonNode = (TaxonNode) taxonNodeDao.findByUuid(uuid3);
         assertNotNull("findByUuid should return a taxon node", taxonNode);
     }
 
@@ -84,7 +85,7 @@ public class TaxonNodeDaoHibernateImplTest extends CdmTransactionalIntegrationTe
         assertNotNull("findByUuid should return a taxon tree", classification);
         assertNotNull("classification should have a name",classification.getName());
         assertEquals("classification should have a name which is 'Name'",classification.getName().getText(),"Name");
-        TaxonNode taxNode = (TaxonNode) taxonNodeDao.findByUuid(uuid1);
+        TaxonNode taxNode = (TaxonNode) taxonNodeDao.findByUuid(uuid3);
         TaxonNode taxNode2 = (TaxonNode) taxonNodeDao.findByUuid(uuid2);
         Set<TaxonNode> rootNodes = new HashSet<TaxonNode>();
 
@@ -92,18 +93,16 @@ public class TaxonNodeDaoHibernateImplTest extends CdmTransactionalIntegrationTe
 
 
         for (TaxonNode rootNode : rootNodes){
-            classification.addChildNode(rootNode, rootNode.getReference(), rootNode.getMicroReference(), rootNode.getSynonymToBeUsed());
+            classification.addChildNode(rootNode, rootNode.getReference(), rootNode.getMicroReference()); //, rootNode.getSynonymToBeUsed()
         }
 
-        taxNode.addChildNode(taxNode2, null, null,null);
+        taxNode.addChildNode(taxNode2, null, null);
 
         Taxon taxon2 = taxNode2.getTaxon();
         Taxon taxon = taxNode.getTaxon();
-        UUID uuidTaxon = taxon.getUuid();
-        UUID uuidTaxon2 = taxon2.getUuid();
-
+        
         List<TaxonBase> taxa = taxonDao.getAllTaxonBases(10, 0);
-        assertEquals("there should be only two taxa", 5, taxa.size());
+        assertEquals("there should be only 5 taxa", 5, taxa.size());
 
         taxonNodeDao.delete(taxNode2);
 
@@ -114,6 +113,23 @@ public class TaxonNodeDaoHibernateImplTest extends CdmTransactionalIntegrationTe
         classification = classificationDao.findByUuid(UUID.fromString("aeee7448-5298-4991-b724-8d5b75a0a7a9"));
         assertEquals("The tree should be null", null, classification);
 
-
+    }
+    
+    @Test
+    @DataSet
+    public void testSortIndex() {
+    	TaxonNode taxonNode = (TaxonNode) taxonNodeDao.findByUuid(uuid3);
+        TaxonNode node2 = taxonNode.getChildNodes().get(1);
+        Assert.assertEquals(uuid2, node2.getUuid());
+        //move node
+        taxonNode.addChildNode(node2, 0, null, null);
+        taxonNodeDao.saveOrUpdate(taxonNode);
+        commitAndStartNewTransaction(new String[]{"TAXONNODE","CLASSIFICATION_TAXONNODE"});
+        taxonNode = (TaxonNode) taxonNodeDao.findByUuid(uuid3);
+        node2 = taxonNode.getChildNodes().get(0);
+        Assert.assertEquals("node2 must now be first in the list", uuid2, node2.getUuid());
+        TaxonNode node1 = taxonNode.getChildNodes().get(1);
+        Assert.assertEquals("node1 must now be second in the list", uuid1, node1.getUuid());
+        
     }
 }
diff --git a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/hibernate/CacheStrategyGeneratorTest.java b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/hibernate/CacheStrategyGeneratorTest.java
index 831235d5dd..83e0f0621a 100644
--- a/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/hibernate/CacheStrategyGeneratorTest.java
+++ b/cdmlib-persistence/src/test/java/eu/etaxonomy/cdm/persistence/hibernate/CacheStrategyGeneratorTest.java
@@ -18,29 +18,36 @@ import java.util.UUID;
 import org.apache.log4j.Logger;
 import org.junit.Assert;
 import org.junit.Before;
+import org.junit.Ignore;
 import org.junit.Test;
 import org.unitils.dbunit.annotation.DataSet;
+import org.unitils.dbunit.annotation.ExpectedDataSet;
 import org.unitils.spring.annotation.SpringBeanByType;
 
 import eu.etaxonomy.cdm.model.agent.Person;
 import eu.etaxonomy.cdm.model.agent.Team;
+import eu.etaxonomy.cdm.model.common.TimePeriod;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.Rank;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
+import eu.etaxonomy.cdm.model.reference.IArticle;
 import eu.etaxonomy.cdm.model.reference.IBook;
+import eu.etaxonomy.cdm.model.reference.IJournal;
+import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.cdm.persistence.dao.agent.IAgentDao;
 import eu.etaxonomy.cdm.persistence.dao.name.ITaxonNameDao;
+import eu.etaxonomy.cdm.persistence.dao.reference.IReferenceDao;
 import eu.etaxonomy.cdm.test.integration.CdmIntegrationTest;
+import eu.etaxonomy.cdm.test.integration.CdmTransactionalIntegrationTest;
 
 /**
  * @author a.mueller
  * @created 18.03.2009
- * @version 1.0
  */
-public class CacheStrategyGeneratorTest extends CdmIntegrationTest {
+public class CacheStrategyGeneratorTest extends CdmTransactionalIntegrationTest {
 	private static Logger logger = Logger.getLogger(CacheStrategyGeneratorTest.class);
 
 	private UUID uuid;
@@ -52,6 +59,9 @@ public class CacheStrategyGeneratorTest extends CdmIntegrationTest {
 	@SpringBeanByType
 	private IAgentDao agentDao;
 
+	@SpringBeanByType
+	private IReferenceDao referenceDao;
+	
 	/**
 	 * @throws java.lang.Exception
 	 */
@@ -77,7 +87,7 @@ public class CacheStrategyGeneratorTest extends CdmIntegrationTest {
 	 */
 	@Test
 	@DataSet("CacheStrategyGeneratorTest.xml")
-	//@ExpectedDataSet
+	@ExpectedDataSet
 	public void testOnSaveOrUpdateNames() {
 		//names
 		BotanicalName name =  (BotanicalName)cdmEntityDaoBase.findByUuid(UUID.fromString("a49a3963-c4ea-4047-8588-2f8f15352730"));
@@ -126,30 +136,17 @@ public class CacheStrategyGeneratorTest extends CdmIntegrationTest {
 	 */
 	@Test
 	@DataSet("CacheStrategyGeneratorTest.xml")
-	//@ExpectedDataSet
+	@ExpectedDataSet
 	public void testOnSaveOrUpdateAgents() {
-
-//		646dad4b-0f0e-4f5a-b059-8099ad9a6125
-//		ca904533-2a70-49f3-9a0e-5e4bcc12c154
-//		4c4e15e3-3a4f-4505-900a-fae2555ac9e4
 		
 		//person
 		Person person1;
 		Person person2;
-		Person person3;person1 = Person.NewInstance();
+		Person person3;
 		
-		person1.setUuid(UUID.fromString("646dad4b-0f0e-4f5a-b059-8099ad9a6125"));
-		person1.setFirstname("P1FN");
-		person1.setLastname("P1LN");
-		person1.setPrefix("Dr1.");
-		person1.setSuffix("Suff1");
+		person1 = makePerson1();
 		
-		person2 = Person.NewInstance();
-		person2.setUuid(UUID.fromString("ca904533-2a70-49f3-9a0e-5e4bcc12c154"));
-		person2.setNomenclaturalTitle("P2NomT");
-		person2.setLastname("P2LN");
-		person2.setFirstname("P2FN");
-		person2.setSuffix("P2Suff");
+		person2 = makePerson2();
 		
 		person3 = Person.NewInstance(); //empty person
 		person3.setUuid(UUID.fromString("4c4e15e3-3a4f-4505-900a-fae2555ac9e4"));
@@ -177,7 +174,63 @@ public class CacheStrategyGeneratorTest extends CdmIntegrationTest {
 		Assert.assertEquals(team1, team2);
 
 	}
+
+	private Person makePerson1() {
+		Person person1;
+		person1 = Person.NewInstance();
+		
+		person1.setUuid(UUID.fromString("646dad4b-0f0e-4f5a-b059-8099ad9a6125"));
+		person1.setFirstname("P1FN");
+		person1.setLastname("P1LN");
+		person1.setPrefix("Dr1.");
+		person1.setSuffix("Suff1");
+		return person1;
+	}
+
+	private Person makePerson2() {
+		Person person2;
+		person2 = Person.NewInstance();
+		person2.setUuid(UUID.fromString("ca904533-2a70-49f3-9a0e-5e4bcc12c154"));
+		person2.setNomenclaturalTitle("P2NomT");
+		person2.setLastname("P2LN");
+		person2.setFirstname("P2FN");
+		person2.setSuffix("P2Suff");
+		return person2;
+	}
 	
+	/**
+	 * Test method for {@link eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase#saveOrUpdate(eu.etaxonomy.cdm.model.common.CdmBase)}.
+	 */
+	@Test
+	@DataSet("CacheStrategyGeneratorTest.xml")
+	@ExpectedDataSet
+	//TODO correct abbrevTitleCache for article still unclear (open question: with or without article title ?)
+	public void testOnSaveOrUpdateReferences() {
+		//References
+		IJournal journal1 = ReferenceFactory.newJournal();
+		Person journalAuthor = makePerson1();
+		
+		journal1.setTitle("My journal");
+		journal1.setUuid(UUID.fromString("a7fdf3b8-acd8-410a-afcd-1768d29d67e9"));
+		journal1.setAbbrevTitle("M. Journ.");
+		journal1.setAuthorTeam(journalAuthor);
+		
+		referenceDao.save((Reference<?>)journal1);
+		
+		Person articleAuthor = makePerson2();
+		IArticle article1 = ReferenceFactory.newArticle();
+		article1.setUuid(UUID.fromString("eb090fbc-5895-405c-aba5-cac287efb128"));
+		article1.setAbbrevTitle("M. Art.");
+		article1.setVolume("1");
+		article1.setDatePublished(TimePeriod.NewInstance(1972));
+		article1.setInJournal(journal1);
+		article1.setAuthorTeam(articleAuthor);
+		article1.getAbbrevTitleCache();
+		
+		referenceDao.saveOrUpdate((Reference<?>)article1);
+		
+		commit();
+	}
 }	
 	
 
